/**
 *
 * This file is auto-generated. Do not edit manually: changes may be erased.
 * Generated by Aqua compiler: https://github.com/fluencelabs/aqua/. 
 * If you find any bugs, please write an issue on GitHub: https://github.com/fluencelabs/aqua/issues
 * Aqua version: 0.1.5-142
 *
 */
import { RequestFlowBuilder } from '@fluencelabs/fluence/dist/api.unstable';



export async function askAllAndSend(client, peer) {
    let request;
    const promise = new Promise((resolve, reject) => {
        request = new RequestFlowBuilder()
            .disableInjections()
            .withRawScript(
                `
(xor
 (seq
  (seq
   (seq
    (seq
     (seq
      (call %init_peer_id% ("getDataSrv" "-relay-") [] -relay-)
      (call %init_peer_id% ("getDataSrv" "peer") [] peer)
     )
     (call -relay- ("op" "identity") [])
    )
    (xor
     (seq
      (seq
       (seq
        (call peer ("peer" "identify") [] ident)
        (call peer ("dist" "list_blueprints") [] blueprints)
       )
       (call peer ("dist" "list_modules") [] modules)
      )
      (call peer ("srv" "list") [] services)
     )
     (seq
      (call -relay- ("op" "identity") [])
      (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 1])
     )
    )
   )
   (call -relay- ("op" "identity") [])
  )
  (call %init_peer_id% ("event" "all_info") [peer ident services blueprints modules])
 )
 (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 2])
)

            `,
            )
            .configHandler((h) => {
                h.on('getDataSrv', '-relay-', () => {
                    return client.relayPeerId;
                });
                h.on('getDataSrv', 'peer', () => {return peer;});
                
                h.onEvent('errorHandlingSrv', 'error', (args) => {
                    // assuming error is the single argument
                    const [err] = args;
                    reject(err);
                });
            })
            .handleScriptError(reject)
            .handleTimeout(() => {
                reject('Request timed out for askAllAndSend');
            })
            .build();
    });
    await client.initiateFlow(request);
    return Promise.race([promise, Promise.resolve()]);
}
      


export async function findAndAskNeighboursSchema(client, relayPeerId, clientId) {
    let request;
    const promise = new Promise((resolve, reject) => {
        request = new RequestFlowBuilder()
            .disableInjections()
            .withRawScript(
                `
(xor
 (seq
  (seq
   (seq
    (seq
     (call %init_peer_id% ("getDataSrv" "-relay-") [] -relay-)
     (call %init_peer_id% ("getDataSrv" "relayPeerId") [] relayPeerId)
    )
    (call %init_peer_id% ("getDataSrv" "clientId") [] clientId)
   )
   (call -relay- ("op" "identity") [])
  )
  (xor
   (seq
    (call relayPeerId ("kad" "neighborhood") [clientId false] neighbors)
    (fold neighbors n
     (par
      (xor
       (seq
        (call n ("kad" "neighborhood") [clientId false] neighbors2)
        (fold neighbors2 n2
         (seq
          (seq
           (seq
            (xor
             (seq
              (seq
               (seq
                (call n2 ("peer" "identify") [] ident)
                (call n2 ("dist" "list_blueprints") [] blueprints)
               )
               (call n2 ("dist" "list_modules") [] modules)
              )
              (call n2 ("srv" "list") [] services)
             )
             (seq
              (call -relay- ("op" "identity") [])
              (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 1])
             )
            )
            (call -relay- ("op" "identity") [])
           )
           (call n ("event" "all_info") [n2 ident services blueprints modules])
          )
          (next n2)
         )
        )
       )
       (seq
        (call -relay- ("op" "identity") [])
        (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 2])
       )
      )
      (seq
       (seq
        (seq
         (call -relay- ("op" "identity") [])
         (next n)
        )
        (call -relay- ("op" "identity") [])
       )
       (call %init_peer_id% ("op" "identity") [])
      )
     )
    )
   )
   (seq
    (seq
     (call -relay- ("op" "identity") [])
     (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 3])
    )
    (call -relay- ("op" "identity") [])
   )
  )
 )
 (seq
  (call -relay- ("op" "identity") [])
  (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 4])
 )
)

            `,
            )
            .configHandler((h) => {
                h.on('getDataSrv', '-relay-', () => {
                    return client.relayPeerId;
                });
                h.on('getDataSrv', 'relayPeerId', () => {return relayPeerId;});
h.on('getDataSrv', 'clientId', () => {return clientId;});
                
                h.onEvent('errorHandlingSrv', 'error', (args) => {
                    // assuming error is the single argument
                    const [err] = args;
                    reject(err);
                });
            })
            .handleScriptError(reject)
            .handleTimeout(() => {
                reject('Request timed out for findAndAskNeighboursSchema');
            })
            .build();
    });
    await client.initiateFlow(request);
    return Promise.race([promise, Promise.resolve()]);
}
      


export async function getAll(client, relayPeerId, knownPeers) {
    let request;
    const promise = new Promise((resolve, reject) => {
        request = new RequestFlowBuilder()
            .disableInjections()
            .withRawScript(
                `
(xor
 (seq
  (seq
   (seq
    (seq
     (seq
      (call %init_peer_id% ("getDataSrv" "-relay-") [] -relay-)
      (call %init_peer_id% ("getDataSrv" "relayPeerId") [] relayPeerId)
     )
     (call %init_peer_id% ("getDataSrv" "knownPeers") [] knownPeers)
    )
    (par
     (seq
      (seq
       (seq
        (call -relay- ("op" "identity") [])
        (xor
         (seq
          (seq
           (seq
            (call relayPeerId ("peer" "identify") [] ident)
            (call relayPeerId ("dist" "list_blueprints") [] blueprints)
           )
           (call relayPeerId ("dist" "list_modules") [] modules)
          )
          (call relayPeerId ("srv" "list") [] services)
         )
         (seq
          (call -relay- ("op" "identity") [])
          (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 1])
         )
        )
       )
       (call -relay- ("op" "identity") [])
      )
      (call %init_peer_id% ("event" "all_info") [relayPeerId ident services blueprints modules])
     )
     (fold knownPeers peer
      (par
       (seq
        (seq
         (seq
          (call -relay- ("op" "identity") [])
          (xor
           (seq
            (seq
             (seq
              (call peer ("peer" "identify") [] ident0)
              (call peer ("dist" "list_blueprints") [] blueprints0)
             )
             (call peer ("dist" "list_modules") [] modules0)
            )
            (call peer ("srv" "list") [] services0)
           )
           (seq
            (call -relay- ("op" "identity") [])
            (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 2])
           )
          )
         )
         (call -relay- ("op" "identity") [])
        )
        (call %init_peer_id% ("event" "all_info") [peer ident0 services0 blueprints0 modules0])
       )
       (next peer)
      )
     )
    )
   )
   (call -relay- ("op" "identity") [])
  )
  (xor
   (seq
    (call relayPeerId ("kad" "neighborhood") [%init_peer_id% false] neighbors)
    (fold neighbors n
     (par
      (xor
       (seq
        (call n ("kad" "neighborhood") [%init_peer_id% false] neighbors2)
        (fold neighbors2 n2
         (seq
          (seq
           (seq
            (xor
             (seq
              (seq
               (seq
                (call n2 ("peer" "identify") [] ident1)
                (call n2 ("dist" "list_blueprints") [] blueprints1)
               )
               (call n2 ("dist" "list_modules") [] modules1)
              )
              (call n2 ("srv" "list") [] services1)
             )
             (seq
              (call -relay- ("op" "identity") [])
              (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 3])
             )
            )
            (call -relay- ("op" "identity") [])
           )
           (call n ("event" "all_info") [n2 ident1 services1 blueprints1 modules1])
          )
          (next n2)
         )
        )
       )
       (seq
        (call -relay- ("op" "identity") [])
        (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 4])
       )
      )
      (seq
       (seq
        (seq
         (call -relay- ("op" "identity") [])
         (next n)
        )
        (call -relay- ("op" "identity") [])
       )
       (call %init_peer_id% ("op" "identity") [])
      )
     )
    )
   )
   (seq
    (seq
     (call -relay- ("op" "identity") [])
     (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 5])
    )
    (call -relay- ("op" "identity") [])
   )
  )
 )
 (seq
  (call -relay- ("op" "identity") [])
  (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 6])
 )
)

            `,
            )
            .configHandler((h) => {
                h.on('getDataSrv', '-relay-', () => {
                    return client.relayPeerId;
                });
                h.on('getDataSrv', 'relayPeerId', () => {return relayPeerId;});
h.on('getDataSrv', 'knownPeers', () => {return knownPeers;});
                
                h.onEvent('errorHandlingSrv', 'error', (args) => {
                    // assuming error is the single argument
                    const [err] = args;
                    reject(err);
                });
            })
            .handleScriptError(reject)
            .handleTimeout(() => {
                reject('Request timed out for getAll');
            })
            .build();
    });
    await client.initiateFlow(request);
    return Promise.race([promise, Promise.resolve()]);
}
      